import tabelib
import os.path
import sys
from ExtensionClass import Base
from string import split, join, lower
import thread
import array
#import perl
from Products.PluginIndexes.TextIndex.Splitter.ZopeSplitter import ZopeSplitter

csplitter_lock=thread.allocate_lock()

class CSplitter:
    """ First try at a Chinese-capable Splitter. """

    # default for older objects
    stop_syn={}

    def __init__(self, doc, stop_syn=None, encoding='latin1', singlechar=0, indexnumbers=0, maxlen=32, casefolding=0):
        mod_dir = os.path.split(sys.argv[0])[0] or '.'
        tsidb_path = os.path.join(mod_dir, 'tsi.db');
        #print tsidb_path
        
        # process none english data
        ar = array.array('c', doc);
        idx =  0
        while idx < len(ar):
            if ar[idx]>='\xa0': 
                ar[idx]=' '
                idx=idx+1
                ar[idx]=' '
            idx=idx+1
	# To split english word by ZopeSplitter
	sp = ZopeSplitter(ar.tostring(), stop_syn, encoding, singlechar, indexnumbers, maxlen, casefolding)
	ec = sp.split()
	"""
        ec = split(ar.tostring(), ' ')
        ec = filter(lambda x: x != 'EOS' and x != '', ec)
	"""
        #etext = lower( join(ec, ' ') )
        #print 'etext:'+etext
        
        if stop_syn is None:
            self.stop_syn = {}
        else:
            self.stop_syn = stop_syn
        self.encoding = encoding
        self.singlechar = singlechar
        self.indexnumbers = indexnumbers
        self.maxlen = maxlen
        self.casefolding = casefolding
        
	# To split chinese word by libtabe
        csplitter_lock.acquire() # lib is not thread-safe
        c=split(tabelib.sparse_tostr(doc, tsidb_path), ' ');
        csplitter_lock.release()
        
        cc=filter(lambda x: x != 'EOS' and x != '', c)
        #text=join(cc, ' ')
        #print 'ctext:'+text
        
        keywords=[]
        #for i in ec:
        #    keywords.append(i)
        #for i in cc:
        #    keywords.append(i)
	keywords.extend(cc)
	keywords.extend(ec)

        self.keywords=keywords
        self.unparsed=join(keywords, ' ')
        #print self.unparsed

    def __getslice__(self, a, b):
        return self.keywords[a:b]

    def __getitem__(self, a):
        return self.keywords[a]

    def __len__(self):
        return len(self.keywords)

    def indexes(self, a):
        res=[]
        for i in range(len(self)):
                 if self[i]==a:
                    res.append(i)
        return res

    def pos(self, a):
        i=int(a/2)
        x=self.unparsed.find(self[i])
        return (x,x+len(self[i]))

    def split(self):
        return self.keywords
